SystemOrganization addCategory: #'CS528-SetbackProject'!
SystemOrganization addCategory: #'CS528-SetbackProject-Tests'!

TestCase subclass: #CardHandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject-Tests'!

!CardHandTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 11:03'!
testHandAdditionCapacity
|hand deck|
deck:= (Deck createStandardDeck).
hand:= (TestCardHand addCard: deck dealNext).
self assert: (hand cards size) = 1.
(hand addCard: deck dealNext).
self assert: (hand cards size) = 2.
(hand addCard: deck dealNext).
self assert: (hand cards size) = 3.
(hand addCard: deck dealNext).
self assert: (hand cards size) = 4.
(hand addCard: deck dealNext).
self assert: (hand cards size) = 5.
(hand addCard: deck dealNext).
self assert: (hand cards size) = 6.
self should: [ (hand addCard: deck dealNext). ] raise: TestResult error.
! !

!CardHandTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 11:07'!
testHandRemovalCapacity
|hand card|
card:= (Card value: #two suit: #hearts).
hand:= (TestCardHand addCard: card).
self assert: (hand capacity) = 6.
self assert: (hand cards size) = 1.
(hand removeCard: card).
self should: [ (hand removeCard: card). ] raise: TestResult error.
! !

!CardHandTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 11:08'!
testHandUniqueness
|hand card|
card:= (Card value: #two suit: #hearts).
hand:= (TestCardHand addCard: card).
self assert: (hand capacity) = 6.
self assert: (hand cards size) = 1.
(TestCardHand addCard: card).
self assert: (hand cards size) = 1.! !

TestCase subclass: #CardTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject-Tests'!

!CardTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 11:07'!
testCardUniqueness
|card|
card:= (Card value: #two suit: #hearts).
self should: [ card value: #two suit: #hearts ] raise: TestResult error.! !

!CardTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/28/2013 15:29'!
testInvalidCardCreation
self should: [(Card value: #two unit: #two)] raise: TestResult error.
self should: [(Card value: #hearts unit: #hearts)] raise: TestResult error.! !

!CardTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 11:07'!
testSimpleCardCreation
self assert: ((Card value: #two suit: #hearts) value) = #two.
self assert: ((Card value: #two suit: #hearts) suit) = #hearts.! !

TestCase subclass: #DeckTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject-Tests'!

!DeckTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 11:08'!
testDeckCreation
self assert: (TestDeck new cards = nil).
self assert: (TestDeck createStandardDeck cards size = 52).
self assert: (TestDeck createStandardDeck cards includes: (Card value: #ace suit: #hearts)).
self assert: (TestDeck createStandardDeck cards includes: (Card value: #king suit: #diamonds)).
self assert: (TestDeck createStandardDeck cards includes: (Card value: #queen suit: #spades)).
self assert: (TestDeck createStandardDeck cards includes: (Card value: #jack suit: #clubs)).
self assert: (TestDeck createStandardDeck cards includes: (Card value: #ten suit: #hearts)).
self assert: (TestDeck createStandardDeck cards includes: (Card value: #nine suit: #diamonds)).
self assert: (TestDeck createStandardDeck cards includes: (Card value: #eight suit: #spades)).
self assert: (TestDeck createStandardDeck cards includes: (Card value: #seven suit: #clubs)).
self assert: (TestDeck createStandardDeck cards includes: (Card value: #six suit: #clubs)).
self assert: (TestDeck createStandardDeck cards includes: (Card value: #five suit: #hearts)).
self assert: (TestDeck createStandardDeck cards includes: (Card value: #four suit: #diamonds)).
self assert: (TestDeck createStandardDeck cards includes: (Card value: #three suit: #spades)).
self assert: (TestDeck createStandardDeck cards includes: (Card value: #two suit: #clubs)).! !

!DeckTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/28/2013 19:44'!
testDeckDealing
|deck|
deck:= Deck createStandardDeck.
1 to: 52 do: [ :i | deck dealNext ].
self should: [deck dealNext] raise: TestResult error.! !

TestCase subclass: #SetbackTrickTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject-Tests'!

!SetbackTrickTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 14:35'!
testTrickCreation
self assert: (TestTrick leadCard: (Card value: #ace suit: #hearts)) leadCard suit = #hearts.
self assert: (TestTrick leadCard: (Card value: #ace suit: #hearts)) leadCard value = #ace.
self assert: (TestTrick leadCard: (Card value: #ace suit: #hearts)) cards size = 1.! !

!SetbackTrickTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 14:29'!
testTrickCreationNewGame
self assert: (TestTrick playFirstCardOfNewGame: (Card value: #ace suit: #hearts)) leadCard suit = #hearts.
self assert: (TestTrick playFirstCardOfNewGame: (Card value: #ace suit: #hearts)) leadCard value = #ace.
self assert: (TestTrick playFirstCardOfNewGame: (Card value: #ace suit: #hearts)) cards size = 1.
self assert: (TestTrick playFirstCardOfNewGame: (Card value: #ace suit: #hearts)) trumpSuit = #hearts.! !

!SetbackTrickTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 14:39'!
testTrickUniqueCards
|trick card hand|
card:= (Card value: #ace suit: #hearts).
trick:= TestTrick playFirstCardOfNewGame: card.
hand:= TestCardHand addCard: card.
self assert: (trick playCard: card inHand: hand) cards size = 1.! !

Object subclass: #Card
	instanceVariableNames: 'value suit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

!Card commentStamp: '<historical>' prior: 0!
A Card is an instance of a playing card in a standard 52 card french deck.

Instance Variables
	suit:		symbol
	value:		symbol

suit
	- the suit of the card

value
	- the face value, or rank of the card
!

!Card class methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 15:35'!
value: aValue suit: aSuit
((CardProperty possibleSuit includes: aSuit) & (CardProperty valueMapping includesKey: aValue))
ifTrue: [ ^self new value: aValue suit: aSuit ]
ifFalse: [ self error: 'Creation of a card is restricted to only valid suits and face values.' ]! !

!Card methodsFor: 'comparing' stamp: 'TerryTata 6/28/2013 18:15'!
= aCard
^aCard equalToCard: self.! !

!Card methodsFor: 'comparing' stamp: 'TerryTata 6/29/2013 15:30'!
> aCard
"returns true if this card has a higher face value of aCard"
^(CardProperty valueMapping at: value) > (CardProperty valueMapping at: aCard value)! !

!Card methodsFor: '*CS528-SetbackProject' stamp: 'TerryTata 6/28/2013 18:16'!
equalToCard:  aCard
^(self value = aCard value) & (self suit = aCard suit)! !

!Card methodsFor: 'comparing' stamp: 'TerryTata 6/29/2013 10:30'!
hash
^value hash bitXor: suit hash! !

!Card methodsFor: 'printing' stamp: 'TerryTata 6/28/2013 18:37'!
printOn: aStream
(value printOn: aStream). 'of' printOn: aStream. (suit printOn: aStream)! !

!Card methodsFor: 'accessing' stamp: 'TerryTata 6/29/2013 11:07'!
suit
^suit! !

!Card methodsFor: 'accessing' stamp: 'TerryTata 6/29/2013 11:07'!
value
^value! !

!Card methodsFor: 'private' stamp: 'TerryTata 6/29/2013 10:33'!
value: aValue suit: aSuit
((value = nil) & (suit = nil))
ifTrue: [value:= aValue. suit:= aSuit.]
ifFalse: [ self error: 'Card has already been created!!' ]

! !

Object subclass: #CardHand
	instanceVariableNames: 'cards'
	classVariableNames: 'capacity'
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

!CardHand class methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 10:50'!
addCard: aCard
capacity:= self determineCapacity.
^self new addCard: aCard.! !

!CardHand class methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 10:52'!
determineCapacity
"return capacity of default setback hand"
^6! !

!CardHand class methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 12:49'!
suit: aSuit exists: aHand
^(aHand cards select: [ :each | each suit = aSuit]) isNotEmpty ! !

!CardHand methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 10:35'!
addCard: aCard
cards size >= capacity
ifTrue: [ self error: 'Cannot add any more cards to hand!!' ]
ifFalse: [ cards add: aCard. ]
! !

!CardHand methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/28/2013 20:10'!
initialize
cards:= Set new.! !

!CardHand methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 10:35'!
removeCard: aCard
cards size = 0
ifTrue: [ self error: 'Hand is empty!!' ]
ifFalse: [ cards remove: aCard.]! !

CardHand subclass: #TestCardHand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject-Tests'!

!TestCardHand methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 10:37'!
capacity
^capacity! !

!TestCardHand methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 10:37'!
cards
^cards! !

Object subclass: #CardProperty
	instanceVariableNames: ''
	classVariableNames: 'possibleSuit valueMapping'
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

!CardProperty class methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 15:27'!
createPossibleSuits
	possibleSuit := Bag new.
	possibleSuit add: #hearts.
	possibleSuit add: #diamonds.
	possibleSuit add: #clubs.
	possibleSuit add: #spades! !

!CardProperty class methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 15:27'!
createValueMappings
	valueMapping := Dictionary new.
	valueMapping at: #two put: 2.
	valueMapping at: #three put: 3.
	valueMapping at: #four put: 4.
	valueMapping at: #five put: 5.
	valueMapping at: #six put: 6.
	valueMapping at: #seven put: 7.
	valueMapping at: #eight put: 8.
	valueMapping at: #nine put: 9.
	valueMapping at: #ten put: 10.
	valueMapping at: #jack put: 11.
	valueMapping at: #queen put: 12.
	valueMapping at: #king put: 13.
	valueMapping at: #ace put: 14! !

!CardProperty class methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 15:24'!
possibleSuit
possibleSuit = nil
ifTrue: [ self createPossibleSuits ].
^possibleSuit! !

!CardProperty class methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 15:24'!
valueMapping
valueMapping = nil
ifTrue: [ self createValueMappings ].
^valueMapping! !

Object subclass: #Deck
	instanceVariableNames: 'cards currentIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

!Deck class methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/28/2013 15:47'!
createStandardDeck
^self new createStandardDeck! !

!Deck methodsFor: 'private' stamp: 'TerryTata 6/29/2013 15:31'!
createStandardDeck
cards isNil
ifTrue: [ cards:= Array new: 52.
currentIndex:= 1.
CardProperty valueMapping keysDo: [ :value | CardProperty possibleSuit do: [ :suit | cards at: currentIndex put: (Card value: value suit: suit). currentIndex := currentIndex + 1.]].
self shuffle. ]
ifFalse: [ self error: 'Deck has already been created. Shuffle deck instead.' ]! !

!Deck methodsFor: 'dealing' stamp: 'TerryTata 6/28/2013 18:53'!
dealNext
currentIndex:= currentIndex + 1.
^cards at: currentIndex ifAbsent: [ self error: 'The deck has run out of cards!!' ]! !

!Deck methodsFor: 'printing' stamp: 'TerryTata 6/28/2013 18:28'!
printOn: aStream
cards do: [ :card | card printOn: aStream ]! !

!Deck methodsFor: 'shuffling' stamp: 'TerryTata 6/28/2013 19:42'!
shuffle
cards shuffle.
currentIndex:= 0. ! !

Deck subclass: #TestDeck
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject-Tests'!

!TestDeck methodsFor: 'acessors' stamp: 'TerryTata 6/29/2013 10:36'!
cards
^cards! !

!Object methodsFor: '*CS528-SetbackProject' stamp: 'TerryTata 6/28/2013 18:14'!
equalToCard: aCard
^false! !

Object subclass: #SetbackTrick
	instanceVariableNames: 'cards leadCard winningCard'
	classVariableNames: 'trumpSuit'
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

!SetbackTrick class methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 14:17'!
leadCard: aCard
^self new leadCard: aCard! !

!SetbackTrick class methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 14:28'!
playFirstCardOfNewGame: aCard
self trump: aCard suit.
^self leadCard: aCard.! !

!SetbackTrick class methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 15:31'!
trump: aSuit
(CardProperty possibleSuit includes: aSuit)
ifTrue: [ trumpSuit:= aSuit. ]
ifFalse: [ self error: 'An invalid suit was selected as trump' ]! !

!SetbackTrick methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 12:10'!
leadCard: aCard
"this method should only be called once (when the first card is thrown of a new trick)"
(cards isNil) & (leadCard isNil)
ifTrue: [ cards:= Set new. leadCard:= aCard. winningCard:= leadCard. cards add: leadCard. ]
ifFalse: [ self error: 'The lead card has already been thrown!!']! !

!SetbackTrick methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 15:33'!
playCard: aCard inHand: aHand
"plays a card in the current trick. Validates the hand to ensure no cheating occured"
aCard suit = trumpSuit
ifTrue: [ self playTrumpCard: aCard. ]
ifFalse: [ (((CardHand suit: (leadCard suit) exists: aHand) not) | aCard suit = leadCard suit)
	ifTrue: [self playNonTrumpCard: aCard]
		ifFalse: [self error: 'You must play the lead suit or a trump card!!']].
! !

!SetbackTrick methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 13:58'!
playNonTrumpCard: aCard
"plays a trump card in the current trick."
aCard suit = winningCard suit
ifTrue: [ self playNormalCard: aCard. ]
ifFalse: [ cards add: aCard.]! !

!SetbackTrick methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 12:37'!
playNormalCard: aCard
"plays a card in the current trick."
cards add: aCard.
aCard > winningCard 
ifTrue: [ winningCard:= aCard. ]! !

!SetbackTrick methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 12:41'!
playTrumpCard: aCard
"plays a trump card in the current trick."
winningCard suit = trumpSuit
ifTrue: [ self playNormalCard: aCard. ]
ifFalse: [ cards add: aCard. winningCard:= aCard ]! !

SetbackTrick subclass: #TestTrick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject-Tests'!

!TestTrick methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 14:02'!
cards
^cards! !

!TestTrick methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 14:02'!
leadCard
^leadCard! !

!TestTrick methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 14:03'!
trumpSuit
^trumpSuit! !

!TestTrick methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 14:03'!
winningCard
^winningCard! !
